function saveOptions() {
	var prefsc= Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
	prefs = prefsc.getBranch("extensions.viewformattedsource.inlinemode");
	for (var x=0;x<elements.length;x++) {
		prefs.setBoolPref(elements[x],document.getElementById(elements[x]).checked);
	}
	// formatting options
	formatprefs = prefsc.getBranch("extensions.viewformattedsource.formatting");
	for (var x=0;x<formatelements.length;x++) {
		formatprefs.setBoolPref(formatelements[x],document.getElementById(formatelements[x]).checked);
	}
	formatprefs.setBoolPref('showexternalscripts', document.getElementById('showexternalscripts').checked);
	formatprefs.setBoolPref('showcssinfo', document.getElementById('showcssinfo').checked);
	formatprefs.setBoolPref('replaceinvisiblechar', document.getElementById('replaceinvisiblechar').checked);	
}

var elements = new Array('table','tr','td','th','div','span');
var defaults = new Array(true, false, false, false, true, true);

var formatelements = new Array("col_head"
,"col_body"
,"col_div"
,"col_span"
,"col_p"
,"col_font"
,"col_map"
,"col_table"
,"col_tr"
,"col_td"
,"col_thead"
,"col_tbody"
,"col_th"
,"col_ul"
,"col_ol"
,"col_dl"
,"col_script"
,"col_noscript"
,"col_style"
,"col_form"
,"col_select"
,"col_optgroup"
,"col_fieldset"
,"col_legend"
,"col_frameset"
,"col_frame"
,"col_noframes"
,"col_link");

var formatdefaults = new Array(true,
true,
true,
true,
true,
false,
true,
true,
true,
true,
false,
false,
true,
true,
true,
true,
true,
true,
true,
true,
true,
false,
false,
false,
false,
false,
false,
true);

function loadValues() {
	var prefsc = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
	prefs = prefsc.getBranch("extensions.viewformattedsource.inlinemode");
  for (var x=0;x<elements.length;x++) {		
  	try {
  		var v = prefs.getBoolPref(elements[x]);
			document.getElementById(elements[x]).checked = v;
		} catch (E) {
			document.getElementById(elements[x]).checked = defaults[x];
		}
	}
	// formatting options
	formatprefs = prefsc.getBranch("extensions.viewformattedsource.formatting");
  for (var x=0;x<formatelements.length;x++) {		
  	try {
  		var v = formatprefs.getBoolPref(formatelements[x]);
			document.getElementById(formatelements[x]).checked = v;
		} catch (E) {
			document.getElementById(formatelements[x]).checked = formatdefaults[x];
		}
	}
	try {
		document.getElementById('showexternalscripts').checked = formatprefs.getBoolPref('showexternalscripts');
	} catch (E) {
		document.getElementById('showexternalscripts').checked = true;
	}
	try {
		document.getElementById('showcssinfo').checked = formatprefs.getBoolPref('showcssinfo');
	} catch (E) {
		document.getElementById('showcssinfo').checked = true;
	}	
	
	try {
		document.getElementById('replaceinvisiblechar').checked = formatprefs.getBoolPref('replaceinvisiblechar');
	} catch (E) {
		document.getElementById('replaceinvisiblechar').checked = false;
	}		
}

function getInlineModeArray() {
	var blocks = new Array();
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
	prefs = prefs.getBranch("extensions.viewformattedsource.inlinemode");
	var onoroff;
  for (var x=0;x<elements.length;x++) {		
  	try {
  		var v = prefs.getBoolPref(elements[x]);
			onoroff = v;
		} catch (E) {
			onoroff = defaults[x];
		}
		if (onoroff==true) {
			blocks.push(elements[x]);
		}
	}	
	return blocks;
}

